<?php

/*------------------------------------------------------------------------
# com_invoices - Invoice Manager for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2012 - 2016 JoomlaThat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.joomlathat.com
# Technical Support:	Forum - http://www.joomlathat.com/support
-------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class  PlgSystemInvoicemanager_virtuemart extends JPlugin
{

	function __construct(& $subject, $config)
	{

		$lang = JFactory::getLanguage();
		$lang->load('com_invoices', JPATH_SITE);

		parent::__construct($subject, $config);

	}

	function plgVmConfirmedOrder($cart, $order) {

		  if(in_array($order['details']['BT']->order_status, $this->params->get('activate_on', array('C')))){

				$details = $order['details']['BT'] ;
				$orderitems = $order['items'] ;
				$this->create_invoice($details, $orderitems);

		  }

		return true;
	}

	function plgVmOnUpdateOrderPayment($data,$old_order_status){

		if(in_array($data->order_status, $this->params->get('activate_on', array('C')))){

				$db = JFactory::getDBO();

				$query = " SELECT ord.*, u.* FROM #__virtuemart_orders AS ord LEFT JOIN #__virtuemart_order_userinfos AS u ON u.virtuemart_order_id = ord.virtuemart_order_id AND u.address_type = 'BT' WHERE ord.virtuemart_order_id = ".$data->virtuemart_order_id ;
				$db->setQuery($query);
				$details = $db->loadObject();

				$query = " SELECT * FROM #__virtuemart_order_items WHERE virtuemart_order_id = ".$data->virtuemart_order_id ;
				$db->setQuery($query);
				$orderitems = $db->loadObjectList();

				$this->create_invoice($details, $orderitems);

		  }

	}

	function create_invoice($details, $orderitems){

		require_once(JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'helpers'.DS.'helpers.php');

		$db = JFactory::getDBO();

		$is_new = false;
		$must_update = false ;
		$invoice_id = 0 ;

		$component = "com_virtuemart" ;

		//we check if this particular order had already been tracked
		$query = " SELECT id FROM #__invoices_invoices WHERE external_type = '".$component."' AND external_id = ".$details->virtuemart_order_id;
		$db->setQuery($query);
		$exists = $db->loadResult();

		//if it didn't exist, we attemp to create the conversion
		if(!$exists){
			$is_new = true ;
		}
		else{
			$must_update = true ;
			$invoice_id = $exists;
		}

		if($is_new || $must_update){

			$params = JComponentHelper::getParams( 'com_invoices' );

			$query = ' SELECT i.real_invoice_num FROM #__invoices_invoices as i WHERE i.type = 1 '.
					 ' ORDER BY i.id DESC ';
			$db->setQuery( $query );
			$real_invoice_num = $db->loadResult() + 1;
			$invoice_num = InvoicesHelper::getInvoiceNum($real_invoice_num) ;

			$invoice_date = date('Y-m-d H:i:s');

			if($invoice_id){
				//the invoice already exists. We don't update the invoice number
				$invoice_num = null;
				$real_invoice_num = null;
				$invoice_date = null;
			}

			$taxes = array();

			$query = " SELECT country_name FROM #__virtuemart_countries WHERE virtuemart_country_id = ".(int)$details->virtuemart_country_id;
			$db->setQuery($query);
			$country = $db->loadResult();

			$query = " SELECT state_name FROM #__virtuemart_states WHERE virtuemart_state_id = ".(int)$details->virtuemart_state_id;
			$db->setQuery($query);
			$state = $db->loadResult();

			$invoice_data = array(
								"id" => $invoice_id ,
								"to_name" => $details->first_name." ".$details->middle_name." ".$details->last_name ,
								"to_company" => $details->company,
								"to_address" => $details->address_1 . "\n" . $details->address_2,
								"to_email" => $details->email,
								"to_zipcode" => $details->zip,
								"to_city" => $details->city,
								"to_state" => $state,
								"to_country" => $country,
								"to_phone" => $details->phone_1,
								"to_vatid" => "",
								"vincular_cliente_checkbox" => 2,
								"from_name" => $params->get('from_name'),
								"from_address" => $params->get('from_address'),
								"from_num" => $params->get('from_num'),
								"from_url" => $params->get('from_url'),
								"from_email" => $params->get('from_email'),
								"from_phone" => $params->get('from_phone'),
								"invoice_num" => $invoice_num,
								"real_invoice_num" => $real_invoice_num,
								"invoice_date" => $invoice_date,
								"template_id" => $params->get('invoice_template'),
								"currency_id" => $params->get('currency_id'),
								"language" => $params->get('default_language', 'en-GB'),
								"publish" => $this->params->get('activation'),
								"start_publish" => "",
								"end_publish" => "",
								"joomla_user_id" => $details->virtuemart_user_id,
								"taxes" => $taxes,
								"status" => "",
								"external_type" => $component,
								"external_id" => $details->virtuemart_order_id,
								"external_ref" => $details->order_number,
								"sendemail" => $this->params->get('sendemail', 0),
								"discount" => abs($details->coupon_discount)
								) ;

			$items = array();

			foreach($orderitems as $orderitem){

				$product_exists = 0 ;

				if($must_update){
					$query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."' AND product_id = ".$orderitem->virtuemart_product_id;
					$db->setQuery($query);
					$product_exists = $db->loadResult();
				}

				$product_id = $product_exists ;

				$tax = ( $orderitem->product_tax / $orderitem->product_item_price ) * 100 ;

				$items[] = array(
									"id" => $product_id,
									"sku" => $orderitem->order_item_sku,
									"name" => $orderitem->order_item_name,
									"desc" => $orderitem->order_item_name,
									"value" => $orderitem->product_item_price,
									"amount" => $orderitem->product_quantity,
									"discount" => abs($orderitem->product_subtotal_discount),
									"tax" => $tax,
									"tax_id" => $this->params->get('tax_id', 0),
									"external_type" => $component,
									"product_id" => $orderitem->virtuemart_product_id,
									);
			}

			//Shipping
			if($details->order_shipment > 0){

				$shipping_name = "";

				$shipping_price = $details->order_shipment ;//- $order->order_shipment_tax ;

				$shipping_item_exists = 0 ;

				if($must_update){
					$query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."_shipping' ";
					$db->setQuery($query);
					$shipping_item_exists = $db->loadResult();
				}

				$shipping_item_id = $shipping_item_exists ;

				$items[] = array(
									"id" => $shipping_item_id,
									"sku" => "",
									"name" => JText::_("Shipping"),
									"desc" => $shipping_name,
									"value" => $shipping_price,
									"amount" => 1,
									"tax" => ( $details->order_shipment_tax / $shipping_price ) * 100,
									"tax_id" => $this->params->get('tax_id', 0),
									"external_type" => $component."_shipping",
									"product_id" => 0,
									);
			}

			//Payment
			if($details->order_payment > 0){

				$payment_name = "";

				$payment_price = $details->order_payment ;//- $order->order_shipment_tax ;

				$payment_item_exists = 0 ;

				if($must_update){
					$query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."_payment' ";
					$db->setQuery($query);
					$payment_item_exists = $db->loadResult();
				}

				$payment_item_id = $payment_item_exists ;

				$items[] = array(
									"id" => $payment_item_id,
									"sku" => "",
									"name" => JText::_("Payment"),
									"desc" => $payment_name,
									"value" => $payment_price,
									"amount" => 1,
									"tax" => ( $details->order_payment_tax / $payment_price ) * 100,
									"tax_id" => $this->params->get('tax_id', 0),
									"external_type" => $component."_payment",
									"product_id" => 0,
									);
			}

			$payment_status = 0;

			if(in_array($details->virtuemart_paymentmethod_id, $this->params->get('payment_status', array()))){

				$payment_status = 1;

			}

			$payments = array();

			$payment_exists = 0 ;

			if($must_update){
				$query = " SELECT id FROM #__invoices_payments WHERE invoice_id = '".$invoice_id."' AND payment_type = 'payment_".$details->virtuemart_paymentmethod_id . "' ";
				$db->setQuery($query);
				$payment_exists = $db->loadResult();
			}

			$payment_id = $payment_exists ;

			$payments[0] = array(
								"id" => $payment_id,
								"payment_details" => "",
								"payment_datetime" => date('Y-m-d H:i:s'),
								"payment_amount" => $details->order_total,
								"payment_type" => 'payment_' . $details->virtuemart_paymentmethod_id,
								"payment_description" => "Payment",
								"payment_id" => "",
								"payment_status" => $payment_status
								);

			InvoicesHelper::create_invoice($invoice_data, $items, $payments);

		}
	}

	function _logData($data)
	{
		$f = fopen(JPATH_CACHE . '/vm-invoices.txt', 'a');
		fwrite($f, "\n" . date('F j, Y, g:i a') . "\n");
		fwrite($f, print_r($data, true));
		fclose($f);
	}

}
